HDU1026(延时迷宫:BFS+优先队列)

Ignatius and the Princess I

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 16713    Accepted Submission(s): 5327
Special Judge

Problem Description

The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166‘s castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166‘s room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them, he has to kill them. Here is some rules:

1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).
2.The array is marked with some characters and numbers. We define them like this:
. : The place where Ignatius can walk on.
X : The place is a trap, Ignatius should not walk on it.
n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.

Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position.

Input

The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole labyrinth. The input is terminated by the end of file. More details in the Sample Input.

Output

For each test case, you should output "God please help our poor hero." if Ignatius can‘t reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output.

Sample Input

5 6

.XX.1.

..X.2.

2...X.

...XX.

XXXXX.

5 6

.XX.1.

..X.2.

2...X.

...XX.

XXXXX1

5 6

.XX...

..XX1.

2...X.

...XX.

XXXXX.

Sample Output

It takes 13 seconds to reach the target position, let me show you the way.

1s:(0,0)->(1,0)

2s:(1,0)->(1,1)

3s:(1,1)->(2,1)

4s:(2,1)->(2,2)

5s:(2,2)->(2,3)

6s:(2,3)->(1,3)

7s:(1,3)->(1,4)

8s:FIGHT AT (1,4)

9s:FIGHT AT (1,4)

10s:(1,4)->(1,5)

11s:(1,5)->(2,5)

12s:(2,5)->(3,5)

13s:(3,5)->(4,5)

FINISH

It takes 14 seconds to reach the target position, let me show you the way.

1s:(0,0)->(1,0)

2s:(1,0)->(1,1)

3s:(1,1)->(2,1)

4s:(2,1)->(2,2)

5s:(2,2)->(2,3)

6s:(2,3)->(1,3)

7s:(1,3)->(1,4)

8s:FIGHT AT (1,4)

9s:FIGHT AT (1,4)

10s:(1,4)->(1,5)

11s:(1,5)->(2,5)

12s:(2,5)->(3,5)

13s:(3,5)->(4,5)

14s:FIGHT AT (4,5)

FINISH

God please help our poor hero.

FINISH

#include <iostream>
#include <queue>
using namespace std;
const int MAXN=105;
const int INF=0x3f3f3f3f;
struct Node{
    int y,x,hp,step,id,pre;
    Node(){}
    Node(int y,int x,int hp,int step,int id,int pre)
    {
        this->y=y;
        this->x=x;
        this->hp=hp;
        this->step=step;
        this->id=id;
        this->pre=pre;
    }
    bool operator<(const Node& no)const
    {
        return step > no.step;
    }
}path[10005];
int tot;
int n,m;
int t[MAXN][MAXN];
char mz[MAXN][MAXN];
int dy[4]={0,1,0,-1};
int dx[4]={1,0,-1,0};
int start;
int time;
void print(int k)
{
    Node now=path[k];
    if(now.pre==-1)
    {
        ++time;
        cout<<time<<"s:("<<now.y<<","<<now.x<<")->";
        return ;
    }
    print(now.pre);
    cout<<"("<<now.y<<","<<now.x<<")"<<endl;
    for(int i=0;i<now.hp;i++)
    {
        ++time;
        cout<<time<<"s:FIGHT AT ("<<now.y<<","<<now.x<<")"<<endl;
    }
    time++;
    if(k!=start)    cout<<time<<"s:("<<now.y<<","<<now.x<<")->";
}
void bfs()
{
    tot=0;
    for(int i=0;i<MAXN;i++)
        for(int j=0;j<MAXN;j++)
            t[i][j]=INF;
    priority_queue<Node> que;
    Node now(0,0,0,0,tot,-1);
    path[tot++]=now;
    que.push(now);
    t[0][0]=0;
    while(!que.empty())
    {
        now=que.top();que.pop();
        if(now.y==n-1&&now.x==m-1)
        {
            start=now.id;
            cout<<"It takes "<<path[start].step<<" seconds to reach the target position, let me show you the way."<<endl;
            time=0;
            print(start);
            return ;
        }
        for(int i=0;i<4;i++)
        {
            int ny=now.y+dy[i];
            int nx=now.x+dx[i];
            if(0<=ny&&ny<n&&0<=nx&&nx<m&&mz[ny][nx]!=‘X‘)
            {
                int hp=0;
                if(mz[ny][nx]!=‘.‘)    hp=hp+mz[ny][nx]-‘0‘;
                int nstep=now.step+hp+1;
                if(nstep<t[ny][nx])
                {
                    t[ny][nx]=nstep;
                    Node next=Node(ny,nx,hp,nstep,tot,now.id);
                    que.push(next);
                    path[tot++]=next;
                }
            }
        }
    }
    cout<<"God please help our poor hero."<<endl;
}
int main()
{
    while(cin>>n>>m)
    {
        for(int i=0;i<n;i++)
            cin>>mz[i];
        bfs();
        cout<<"FINISH"<<endl;
    }
    return 0;
}
时间: 2024-10-15 01:22:18

HDU1026(延时迷宫:BFS+优先队列)的相关文章

HDOJ1242(延时迷宫BFS)

代码一: #include<iostream> #include<cstdio> #include<queue> using namespace std; const int MAX_N=205; const int INF=0x30303030; char map[MAX_N][MAX_N]; int N,M; int sx,sy; int gx,gy; int dx[4]={1, 0, -1, 0}; int dy[4]={0, 1, 0, -1}; typedef

hdu 2102 A计划 详细题解 (BFS+优先队列)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 这道题属于BFS+优先队列 开始看到四分之一的AC率感觉有点吓人,后来一做感觉就是模板改了点东西而已,一遍就AC了,不过在主函数和全局变量里面都定义了n和m导致我白白浪费了debug的时间.果然全局变量得小心用啊. 跟模板一样的,定义一个结构体,只不过多加了个参数,就是迷宫的层数,我用0代表第一层,1代表第二层,这在数组里面会体现的. struct node { int index;//层数

hdu 2102 A计划 具体题解 (BFS+优先队列)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 这道题属于BFS+优先队列 開始看到四分之中的一个的AC率感觉有点吓人,后来一做感觉就是模板改了点东西而已,一遍就AC了,只是在主函数和全局变量里面都定义了n和m导致我白白浪费了debug的时间. 果然全局变量得小心用啊. 跟模板一样的,定义一个结构体,仅仅只是多加了个參数,就是迷宫的层数,我用0代表第一层.1代表第二层,这在数组里面会体现的. struct node { int index;

HDU-2102-A计划(BFS+优先队列)

Problem Description 可怜的公主在一次次被魔王掳走一次次被骑士们救回来之后,而今,不幸的她再一次面临生命的考验.魔王已经发出消息说将在T时刻吃掉公主,因为他听信谣言说吃公主的肉也能长生不老.年迈的国王正是心急如焚,告招天下勇士来拯救公主.不过公主早已习以为常,她深信智勇的骑士LJ肯定能将她救出. 现据密探所报,公主被关在一个两层的迷宫里,迷宫的入口是S(0,0,0),公主的位置用P表示,时空传输机用#表示,墙用*表示,平地用.表示.骑士们一进入时空传输机就会被转到另一层的相对位

[ACM] hdu 1242 Rescue (BFS+优先队列)

Rescue Problem Description Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison. Angel's friends want to save Angel. Their task is:

Battle City BFS+优先队列

Battle City Many of us had played the game "Battle city" in our childhood, and some people (like me) even often play it on computer now. What we are discussing is a simple edition of this game. Given a map that consists of empty spaces, rivers,

hdu 1242 Rescue(bfs+优先队列)

Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison. Angel's friends want to save Angel. Their task is: approach Angel. We assume

hdu 1242 Rescue (BFS+优先队列)

题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=1242 这道题目我是用BFS+优先队列做的.听说只用bfs会超时. 因为这道题有多个营救者,所以我们从被营救者开始bfs,找到最近的营救者就是最短时间. 先定义一个结构体,存放坐标x和y,还有到达当前点(x,y)消耗的时间. struct node { int x,y; int time; friend bool operator < (const node &a,const node &

ZOJ 1649 Rescue(有敌人迷宫BFS)

题意 求迷宫中从a的位置到r的位置需要的最少时间  经过'.'方格需要1s  经过'x'方格需要两秒  '#'表示墙 由于有1s和2s两种情况  需要在基础迷宫bfs上加些判断 令到达每个点的时间初始为无穷大  当从一个点到达该点用的时间比他本来的时间小时  更新这个点的时间并将这个点入队  扫描完全图就得到答案咯 #include<cstdio> #include<cstring> #include<queue> using namespace std; const